﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SortColumnsDesc
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            DataTable t2 = ds.Tables.Add("table2");
            t2.Columns.Add("pid", typeof(int));
            t2.Columns.Add("Name", typeof(string));
            t2.Columns.Add("Quantity", typeof(int));
            t2.Columns.Add("Price", typeof(double));
            t2.Columns.Add("Date", typeof(DateTime));

            ds.Tables["table1"].Rows.Add(new Object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Fruits", 25, 12, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Vegetables", 30, 13, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Cars", 13, 200, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table2"].Rows.Add(new Object[] { 0, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
            ds.Tables["table2"].Rows.Add(new Object[] { 0, "Motorcycles", 10, 320, new DateTime(2005, 10, 05) });
            ds.Tables["table2"].Rows.Add(new Object[] { 0, "Clothes", 40, 69, new DateTime(2009, 02, 28) });
            ds.Tables["table2"].Rows.Add(new Object[] { 0, "Shoes", 24, 40.6, new DateTime(2008, 04, 22) });
            ds.Tables["table2"].Rows.Add(new Object[] { 0, "Games", 53, 50, new DateTime(2012, 05, 10) });
            ds.Tables["table2"].Rows.Add(new Object[] { 0, "Books", 42, 22, new DateTime(2005, 10, 05) });
            ds.Tables["table2"].Rows.Add(new Object[] { 0, "Movies", 38, 19, new DateTime(2009, 02, 28) });

            ds.Relations.Add(t1.Columns["id"], t2.Columns["pid"]);

            ultraGrid1.DataSource = ds;

            
            
        }

        private void ultraGrid1_MouseClick(object sender, MouseEventArgs e)
        {
            var el = ultraGrid1.DisplayLayout.UIElement.ElementFromPoint(e.Location);
            var header = el.GetAncestor(typeof(HeaderUIElement)) as HeaderUIElement;

            if (header != null)
            {

                var col = header.Header.Column;
                var sortIndicator = col.SortIndicator;

                if (sortIndicator == SortIndicator.None)
                {
                    col.SortIndicator = SortIndicator.Ascending;// Descending;
                }
            }
        }
    }
}
